<?php
   /*
   Plugin Name: جست و جوی ایجکس
   Plugin URI: http://www.fingerfish.com/wp-plugin-ajax-search/
   Description: با استفاده از این پلاگین کاربران میتوانند جست و جو در سایت شما انجام دهند بدون بارگذاری دوباره صفحه!
   Version: 1.0
   Author: وحید محمدی
   Author URI: http://blog.vahidd.com
   License: GPL2
   */
?>
<?php 
wp_enqueue_script('dynamic-search-ajax-handle', plugin_dir_url(__FILE__). 'cardoza_ajax_search.js', array('jquery'));
wp_localize_script('dynamic-search-ajax-handle', 'the_ajax_script', array('ajaxurl' => admin_url('admin-ajax.php')));

add_action("plugins_loaded", "cardoza_ajax_search_init");
add_action('wp_ajax_the_search_text','the_search_function');
add_action('wp_ajax_nopriv_the_search_text','the_search_function');

function widget_cardoza_ajax_search($args){
	extract($args);
	
	echo $before_widget;

	echo $before_title;
	echo "جست و جو";
	echo $after_title;
	
	echo '
	<form id="search_form">
	<input type="text" name="srch_txt" id="srch_txt" oninput="javascipt:do_search_js(document.getElementById(\'srch_txt\').value)" />
	<input name="action" type="hidden" value="the_search_text" />
	</form>';

	echo '<div id="search_result">کلمه ای را که میخواهید جست و جو کنید را در فیلد وارد نمایید.</div>';

	echo $after_widget;
	add_shortcode("cd_search", "widget_cardoza_ajax_search");
}

function the_search_function(){
	if(isset($_POST['srch_txt'])){
		$search_string = stripslashes($_POST['srch_txt']);
		if(!empty($search_string)){
			global $wpdb;
			$search_result_posts = $wpdb->get_col("select ID from $wpdb->posts where post_title like '%".$search_string."%' AND post_status = 'publish'");
			if(sizeof($search_result_posts)!=0){
				$args = array('post__in'=>$search_result_posts);
				$res = new WP_Query($args);
				echo '<ul>';
				while ( $res->have_posts() ) : $res->the_post();?>
					<li><a href="<?php the_permalink();?>"><?php the_title();?></a></li>
				<?php 
				endwhile;
				echo '</ul>';
			}
			else echo "نتیجه ای برای جست و جوی شما یافت نشد.";
		}
		else echo "کلمه ای که میخواهید جست و جو کنید را در فیلد وارد کنید.";
		
	wp_reset_query();
	die();
	}
}

function cardoza_ajax_search_init(){
	register_sidebar_widget(__('Cardoza\'s AJAX Search'), 'widget_cardoza_ajax_search');
}
?>